/** 
 *   FIXME ....
 *
 *   (c) Copyright 2004 Federico Bareilles <fede@iar.unlp.edu.ar>,
 *   Instituto Argentino de Radio Astronomia (IAR).
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License as
 *   published by the Free Software Foundation; either version 2 of
 *   the License, or (at your option) any later version.
 *     
 *   The author does NOT admit liability nor provide warranty for any
 *   of this software. This material is provided "AS-IS" in the hope
 *   that it may be useful for others.
 *
 *   TODO: ???
 **/

#ifndef _IB_H
#define _IB_H

#define IB_COMMAND_LINE_LEGEND 80

/* #define NO_IB_PROMPT */

#define IB_MAIN_ADDR      0x00000300
#define IB_BUS_ADDR       0x00000320
#define IB_BASE_ADDR      0x30000000
#define IB_BROADCAST_ADDR 0xffffffff


struct ib_cm_line {
	int addr_f;
	int addr_t;
	int cm_id;
	char arg[IB_COMMAND_LINE_LEGEND];
};


struct ib_dev {
	int fd;
	int transfer;
	int alive;
	char *id; /* FIXME: hay que eliminarlo */
	int addr; /* el nuevo id */
	//char cmd[IB_COMMAND_LINE_LEGEND];
	struct ib_cm_line cmd;
	//int cmd_ind;
	char *mesg;
	struct ib_dev *prev;
	struct ib_dev *next;
};


struct ib_command {
	int cm_id;
	int (*func)(struct ib_dev *cl, 
		    struct ib_dev *current);
	/* ... */
};


#define IB_CM_QUIT       "q"
#define IB_CM_START      "s"
#define IB_CM_STOP       "t"
#define IB_CM_MESSAGE    "m"
#define IB_CM_WHO        "w"
#define IB_CM_MESSAGE_TO "to"
#define IB_CM_WHOAMI     "wa"
#define IB_CM_SID        "sid"


int ib_cm_quit(struct ib_dev *cl, struct ib_dev *current);
int ib_cm_start(struct ib_dev *cl, struct ib_dev *current);
int ib_cm_stop(struct ib_dev *cl, struct ib_dev *current);
int ib_cm_message(struct ib_dev *cl, struct ib_dev *current);
int ib_cm_who(struct ib_dev *cl, struct ib_dev *current);
int ib_cm_message_to(struct ib_dev *cl, struct ib_dev *current);
int ib_cm_whoami(struct ib_dev *cl, struct ib_dev *current);
int ib_cm_set_addr(struct ib_dev *cl, struct ib_dev *current);

int init_iar_bus_local(struct ib_command *cm, int fd_main, char *sock_name );
int init_iar_bus_inet(struct ib_command *cm, int fd_main, int port );

int skip_prompt(char *buff, char **ptrbuff);
int parse_ib_line(char *line, char **from, char **ptrdata, int *cmd);
int ib_cmctl(int fd, char *to, int cmd, ...);

#endif  /* ifndef _IB_H */
